#include "StdAfx.h"

#include "zlib\zlib.h"
#include "unpack.h"
#include "dds.h"

// Archangel .PAK unpacker
// (c) Nikita 2002
//
// demo + retail/ru fix
// (c) CTPAX-X Team 2012
// http://www.CTPAX-X.ru/

// <-- CTPAX-X Team fix

// demo, retail/en, retail/ru
#define MAGICMAX 3
ULONG magicsub[MAGICMAX] = {0, 0x4857, 0x4858};
ULONG MAGIC = 0;
// #define MAGIC 0x4857

void find_toc_magic(FILE *pak, ULONG toc_offs){
ULONG i, dw;
	for(i = 0; i<MAGICMAX; i++){
		fseek(pak, toc_offs - magicsub[i], SEEK_SET);
		dw = -1;
		fread(&dw, sizeof(ULONG), 1, pak);
		// first file offset - always 8 (header size)
		// actually, we can shuffle files,
		// but in demo/retail version it's always 8
		if(dw == 8){
			MAGIC = magicsub[i];
			break;
		}
	}
}
// CTPAX-X Team fix -->

BOOL ForceDirectories(char *FileName)
{
	PCHAR	dir,dir_orig;
	PCHAR	curdir;
	PCHAR	newdir;
	int		i;

	dir = new CHAR[_MAX_PATH];
	dir_orig = dir;
	curdir = new CHAR[_MAX_PATH];
	newdir = new CHAR[_MAX_PATH];

	_splitpath(FileName,NULL,dir,NULL,NULL);
	if( *dir == 0 )
	{
		return FALSE;
	}
	
	_getcwd(curdir,_MAX_PATH);

	while( *dir )
	{
		i = 0;
		while( *dir != '\\' && *dir != '/' )
		{
			newdir[i] = *dir;
			dir++;
			i++;
		}
		newdir[i] = '\0';
		dir++;

		if( strlen(newdir) == 0 ) continue;

		_mkdir(newdir);
		if( _chdir(newdir) != 0 ) return FALSE;
	}				
	
	_chdir(curdir);

	delete [] dir_orig;
	delete [] curdir;
	delete [] newdir;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////

VOID read_pak_toc(FILE *pak,PULONG Count,PPAK_TOC *toc)
{
	PAK_HEADER	header;
	ULONG		toc_offs;
	ULONG		i;

	fseek(pak,0,SEEK_SET);
	fread(&header,sizeof(PAK_HEADER),1,pak);

	*Count = header.Count;

	*toc = new PAK_TOC[ header.Count ];

	fseek(pak,-4,SEEK_END);
	fread(&toc_offs,sizeof(ULONG),1,pak);

// <-- CTPAX-X Team fix
	find_toc_magic(pak, toc_offs);
// CTPAX-X Team fix -->

	toc_offs -= MAGIC;

	fseek(pak,toc_offs,SEEK_SET);

	//
	// read TOC
	//

	for(i = 0; i < header.Count; i++)
	{
		fread(&(*toc)[i].Offset,4,1,pak);
		fread(&(*toc)[i].Size,4,1,pak);
	}

	for(i = 0; i < header.Count; i++)
	{
		ULONG len;
		fread(&len,4,1,pak);
		fread((*toc)[i].FileName,1,len,pak);
	}

	for(i = 0; i < header.Count; i++)
	{
		USHORT	Signature;
		ULONG	Eof;

		fseek(pak,(*toc)[i].Offset+sizeof(PAK_LOCAL_HEADER),SEEK_SET);
		fread(&Signature,sizeof(USHORT),1,pak);

		(*toc)[i].Packed = ((*toc)[i].Size > sizeof(PAK_LOCAL_HEADER)+2) && (Signature == 0x8B1F);

		fseek(pak,(*toc)[i].Offset+(*toc)[i].Size,SEEK_SET);
		fread(&Eof,sizeof(ULONG),1,pak);

		(*toc)[i].Eof = (Eof == 0x1A);
	}
}

VOID save_pak_toc(FILE *pak,ULONG count,PPAK_TOC toc)
{
	ULONG i;
	ULONG toc_offs = ftell(pak) + MAGIC;

	for(i = 0; i < count; i++)
	{
		fwrite(&toc[i].Offset,4,1,pak);
		fwrite(&toc[i].Size,4,1,pak);
	}

	for(i = 0; i < count; i++)
	{
		ULONG len = strlen(toc[i].FileName)+1;
		fwrite(&len,sizeof(ULONG),1,pak);
		fwrite(toc[i].FileName,1,len,pak);
	}
	fwrite(&toc_offs,sizeof(ULONG),1,pak);
}

/////////////////////////////////////////////////////////////////////////////

VOID unpack_pak_file(PCHAR PakFileName)
{
	FILE		*pak;
	ULONG		count;
	PPAK_TOC	toc;

	pak = fopen(PakFileName,"rb");
	if( !pak )
	{
		printf("Error: can't open file %s\n",PakFileName);
		return;
	}

	read_pak_toc(pak,&count,&toc);

	//
	// dump all files
	//

	for(ULONG i = 0; i < count; i++)
	{
		gzFile				gz;
		PUCHAR				outbuf;
		ULONG				raw_size;
	
		FILE				*out;
		CHAR				OutFileName[ _MAX_PATH ];

		PFILE_HEADER		filehdr;
		TGA_HEADER			tgahdr;

		strcpy(OutFileName,".");
		strcat(OutFileName,toc[i].FileName);
		ForceDirectories(toc[i].FileName);

		if( PCHAR pos = strstr(OutFileName,".texture") )
		{
			strcpy(pos,".texture.dds");
		}

		printf("%03d%%: unpacking %s\n",(i+1)*100/count,OutFileName);

		outbuf = new UCHAR[ toc[i].Size ];
		
		fseek(pak,toc[i].Offset,SEEK_SET);
		fread(outbuf,1,toc[i].Size,pak);

		out = fopen(OutFileName,"wb");
		if( toc[i].Packed )
		{
			fwrite(outbuf+sizeof(PAK_LOCAL_HEADER),1,((PPAK_LOCAL_HEADER)(outbuf))->PackedSize,out);
			raw_size = ((PPAK_LOCAL_HEADER)(outbuf))->RawSize;
		}
		else
		{
			fwrite(outbuf,1,toc[i].Size,out);
			raw_size = toc[i].Size;
		}
		fclose(out);

		delete [] outbuf;

		outbuf = new UCHAR[ raw_size ];

		gz = gzopen(OutFileName,"rb");
		gzread(gz,outbuf,raw_size);
		gzclose(gz);

		out = fopen(OutFileName,"wb");
		if( !out )
		{
			printf("Error: can't create file %s\n",toc[i].FileName);
			continue;
		}

		filehdr = (PFILE_HEADER)outbuf;

		if( filehdr->Sign1 == 'RGB ' || filehdr->Sign1 == 'RGBA' )
		{
			tgahdr.IdentLength = 0;
			tgahdr.ColorMapType = 0;
			tgahdr.ImageType = 2;
			tgahdr.ColorMapOrigin = 0;
			tgahdr.ColorMapLength = 0;
			tgahdr.ColorMapEntrySize = 0;
			tgahdr.XOriginOfImage = 0;
			tgahdr.YOriginOfImage = 0;
			tgahdr.WidthOfImage = (USHORT)filehdr->Width;
			tgahdr.HeightOfImage = (USHORT)filehdr->Height;
			tgahdr.ImagePixelSize = (filehdr->Sign1 == 'RGB ') ? 24 : 32;
			tgahdr.ImageDescriptorByte = 0x08;

			fwrite(&tgahdr,sizeof(TGA_HEADER),1,out);
			fwrite(outbuf+sizeof(FILE_HEADER),1,filehdr->Size,out);
		}
		else if ( filehdr->Sign1 == 'CT3S' )
		{
			ULONG		   sign;
			DDSURFACEDESC2 dds;

			ULONG BlockSize = (filehdr->Sign2 == '1TXD') ? 8 : 16;
			ULONG LinearSize = ((filehdr->Height+3)/4)*((filehdr->Width+3)/4)*BlockSize;

			sign = ' SDD';
			memset(&dds,0,sizeof(DDSURFACEDESC2));
			dds.dwSize = sizeof(DDSURFACEDESC2);
			dds.dwFlags = DDSD_LINEARSIZE | DDSD_PIXELFORMAT | DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS | DDSD_MIPMAPCOUNT;
			dds.dwHeight = filehdr->Height;
			dds.dwWidth = filehdr->Width;
			dds.dwMipMapCount = 0xA;
			dds.dwLinearSize = LinearSize; //filehdr->Size;
			dds.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
			dds.ddpfPixelFormat.dwFlags = DDPF_FOURCC;// | DDPF_ALPHAPIXELS;
			dds.ddpfPixelFormat.dwFourCC = filehdr->Sign2;
			dds.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_MIPMAP | DDSCAPS_COMPLEX;
			dds.ddsCaps.dwCaps2 = DDSCAPS2_MIPMAPSUBLEVEL;

			fwrite(&sign,sizeof(ULONG),1,out);
			fwrite(&dds,sizeof(DDSURFACEDESC2),1,out);
			fwrite(outbuf+sizeof(FILE_HEADER),1,filehdr->Size,out);
		}
		else

		{
			fwrite(outbuf,1,raw_size,out);
		}

		fclose(out);

		delete [] outbuf;
	}

	fclose(pak);

	delete [] toc;
}

VOID update_pak_file(PCHAR PakFileName)
{
	FILE		*pak;
	ULONG		count,i;
	PPAK_TOC	toc;

	CHAR		OutPakFileName[_MAX_PATH];

	pak = fopen(PakFileName,"rb");
	if( !pak )
	{
		printf("Error: can't open file %s\n",PakFileName);
		return;
	}
	read_pak_toc(pak,&count,&toc);
	fclose(pak);

	sprintf(OutPakFileName,"%s.new",PakFileName);
	pak = fopen(OutPakFileName,"wb");
	if( !pak )
	{
		printf("Error: can't create file %s\n",OutPakFileName);
		return;
	}

	//
	// write pak header
	//
	i = 1;
	fwrite(&i,sizeof(ULONG),1,pak);
	fwrite(&count,sizeof(ULONG),1,pak);

	//
	// update all files
	//

	for(i = 0; i < count; i++)
	{
		CHAR	InputFileName[_MAX_PATH];
		FILE	*in;
		ULONG	buf_size;
		PUCHAR	buf;

		// open input file
		strcpy(InputFileName,".");
		strcat(InputFileName,toc[i].FileName);
		if( PCHAR pos = strstr(InputFileName,".texture") )
		{
			strcpy(pos,".texture.dds");
		}

		printf("%03d%%: packing %s\n",(i+1)*100/count,InputFileName);

		in = fopen(InputFileName,"rb");
		if( !in )
		{
			printf("Error: can't open file %s\n",InputFileName);
			continue;
		}

		// get file size
		fseek(in,0,SEEK_END);
		buf_size = ftell(in);
		fseek(in,0,SEEK_SET);

		buf = new UCHAR[ buf_size*2+1024 ];

		_strlwr(InputFileName);
		if( strstr(InputFileName,".tga") )
		{
			TGA_HEADER		tgahdr;
			PFILE_HEADER	filehdr;

			fread(&tgahdr,sizeof(TGA_HEADER),1,in);

			_ASSERT( tgahdr.ImagePixelSize == 32 || tgahdr.ImagePixelSize == 24 );

			filehdr = (PFILE_HEADER)buf;
			filehdr->Sign1 = (tgahdr.ImagePixelSize == 24) ? 'RGB ' : 'RGBA';
			filehdr->Sign2 = 0;
			filehdr->Width = tgahdr.WidthOfImage;
			filehdr->Height = tgahdr.HeightOfImage;
			filehdr->Size = tgahdr.WidthOfImage * tgahdr.HeightOfImage * tgahdr.ImagePixelSize / 8;
			filehdr->Res[0] = 0;
			filehdr->Res[1] = 0;
			filehdr->Res[2] = 0;

			//
			// check 5th bit in Image Descriptor Byte
			//
			if( tgahdr.ImageDescriptorByte & (1 << 5) )
			{
				ULONG len = tgahdr.WidthOfImage * tgahdr.ImagePixelSize / 8;
				ULONG buf_pos = len * (tgahdr.HeightOfImage - 1);
				for(ULONG j = 0; j < tgahdr.HeightOfImage; j++)
				{
					fread(buf+sizeof(FILE_HEADER) + buf_pos,1,len,in);
					buf_pos -= len;
				}
			}
			else
			{
				fread(buf+sizeof(FILE_HEADER),1,filehdr->Size,in);
			}
			buf_size = sizeof(FILE_HEADER) + filehdr->Size;
		}
		else if( strstr(InputFileName,".texture.dds") )
		{
			ULONG			Sign;
			PFILE_HEADER	filehdr;
			DDSURFACEDESC2	dds;

			fread(&Sign,sizeof(ULONG),1,in);
			_ASSERT( Sign == ' SDD' );

			fread(&dds,sizeof(DDSURFACEDESC2),1,in);

			filehdr = (PFILE_HEADER)buf;
			filehdr->Sign1 = 'CT3S';
			filehdr->Sign2 = dds.ddpfPixelFormat.dwFourCC;
			filehdr->Width = dds.dwWidth;
			filehdr->Height = dds.dwHeight;
			filehdr->Size = buf_size - 4 - sizeof(DDSURFACEDESC2);
			filehdr->Res[0] = 0; filehdr->Res[1] = 0; filehdr->Res[2] = 0;

			fread(buf+sizeof(FILE_HEADER),1,filehdr->Size,in);
			buf_size = sizeof(FILE_HEADER) + filehdr->Size;
		}
		else
		{
			// read the whole file
			fread(buf,1,buf_size,in);
		}

		fclose(in);

		toc[i].Offset = ftell(pak);

		if( toc[i].Packed )
		{
			gzFile	tmp;
			ULONG	packed_size;

			tmp = gzopen("tmp.bin","wb");
			gzwrite(tmp,buf,buf_size);
			gzclose(tmp);

			in = fopen("tmp.bin","rb");
			fseek(in,0,SEEK_END);
			packed_size = ftell(in);
			fseek(in,0,SEEK_SET);
			fread(buf,1,packed_size,in);
			fclose(in);

			fwrite(&buf_size,sizeof(ULONG),1,pak);
			fwrite(&packed_size,sizeof(ULONG),1,pak);
			fwrite(buf,1,packed_size,pak);

			DeleteFile("tmp.bin");

			toc[i].Size = 4 +4 + packed_size;
		}
		else
		{
			fwrite(buf,1,buf_size,pak);
			toc[i].Size = buf_size;
		}

		if( toc[i].Eof )
		{
			ULONG eof_sign = 0x1A;
			fwrite(&eof_sign,sizeof(ULONG),1,pak);
		}
		delete [] buf;
	}

	//
	// save TOC
	//
	save_pak_toc(pak,count,toc);

	fclose(pak);

	delete [] toc;
}

VOID main(int argc, char *argv[])
{
	if( argc < 3 )
	{
		printf("Usage: arcrepak.exe <command> filename.pak\n");
		printf("Commands:\n");
		printf("	x	- extract all from pak file\n");
		printf("	u	- update pak file\n");
		return;
	}

	if( stricmp(argv[1],"x") == 0 )
	{
		unpack_pak_file(argv[2]);
	}
	else if ( stricmp(argv[1],"u") == 0 )
	{
		update_pak_file(argv[2]);
	}
	else
	{
		printf("unknown option!\n");
	}
}
