
#pragma pack(1)

typedef struct _PAK_HEADER
{
	ULONG	Res;
	ULONG	Count;
} PAK_HEADER, *PPAK_HEADER;

typedef struct _PAK_LOCAL_HEADER
{
	ULONG	RawSize;
	ULONG	PackedSize;
} PAK_LOCAL_HEADER, *PPAK_LOCAL_HEADER;

typedef struct _FILE_HEADER
{
	ULONG	Sign1;
	ULONG	Sign2;
	ULONG	Width;
	ULONG	Height;
	ULONG	Size;
	ULONG	Res[3];
} FILE_HEADER, *PFILE_HEADER;

typedef struct _TGA_HEADER
{
	UCHAR	IdentLength;
	UCHAR	ColorMapType;
	UCHAR	ImageType;
	USHORT	ColorMapOrigin;
	USHORT	ColorMapLength;
	UCHAR	ColorMapEntrySize;
	USHORT	XOriginOfImage;
	USHORT	YOriginOfImage;
	USHORT	WidthOfImage;
	USHORT	HeightOfImage;
	UCHAR	ImagePixelSize;
	UCHAR	ImageDescriptorByte;
} TGA_HEADER, *PTGA_HEADER;

typedef struct _DDS_HEADER
{
	DWORD	dwSize;					// Size of structure. This member must be set to 124. 
	DWORD	dwFlags;				// Flags to indicate valid fields. Always include DDSD_CAPS, DDSD_PIXELFORMAT, DDSD_WIDTH, DDSD_HEIGHT and either DDSD_PITCH or DDSD_LINEARSIZE.
	DWORD	dwHeight;				// Height of the main image in pixels 
	DWORD	dwWidth;				// Width of the main image in pixels 
	DWORD	dwPitchOrLinearSize;	// For uncompressed formats, this is the number of bytes per scan line (DWORD aligned) for the main image. dwFlags should include DDSD_PITCH in this case. For compressed formats, this is the total number of bytes for the main image. dwFlags should be include DDSD_LINEARSIZE in this case. 
	DWORD	dwDepth;				// For volume textures, this is the depth of the volume. dwFlags should include DDSD_DEPTH in this case. 
	DWORD	dwMipMapCount;			// For items with mipmap levels, this is the total number of levels in the mipmap chain of the main image. dwFlags should include DDSD_MIPMAPCOUNT in this case 
	DWORD	dwReserved1[11];		//
	DWORD	ddpfPixelFormat;		// A 32-byte value that specifies the pixel format structure. 
	WORD	ddsCaps;				// A 16-byte value that specifies the capabilities structure. 
	DWORD	dwReserved2;
} DDS_HEADER, *PDDS_HEADER;
#pragma pack()

typedef struct _PAK_TOC
{
	ULONG	Offset;
	ULONG	Size;
	CHAR	FileName[_MAX_PATH];
	BOOL	Packed;
	BOOL	Eof;
} PAK_TOC, *PPAK_TOC;
